#!/usr/bin/perl

# YOU MUST ENTER THE PATH TO 'BLAT' BELOW:
$blat_path = 'c:/Blat/blat.exe';

# LEAVE THIS FLAG SET TO 'YES':
$use_blat = 'YES';

#---------------------------------------------------------------------------
# ushop_cgiscript.pl
# script version 2.35
#
# uShop On-Line Shopping System
# Copyright (c) 1997-2000, Microburst Technologies, Inc.
# All rights reserved.
#
# SCRIPT SETUP
#
# In order to use this script with uShop, there are a few parameters that
# need to be setup.  These parameters consist of specifying some server
# specific directory paths and some uShop specific options - such as where
# you want to email the order notifications to.
# These parameters have been organized into thirteen (hopefully) simple 
# questions - Each with a full description and example to help you configure
# the ushop_cgiscript.pl for your needs.  Consult the uShop setup 
# instructions for further information.
#
#---------------------------------------------------------------------------


#---------------------------------------------------------------------------
# 1. What is the location of perl on your server?
# This script is written in the perl programming language which a standard
# on all servers.  In order to run this perl script, you must specify the
# location of perl on your server.  Typical locations are /usr/bin/perl,
# /usr/local/bin/perl, and /bin/perl.  You can ask your Internet Service
# Provider for the location of perl on your server.
#---------------------------------------------------------------------------
# The perl path must be specified as the first line of this script (above).


#---------------------------------------------------------------------------
# 2. What type of operating system is running on your server?
# If your server is a Unix machine, set this parameter to "UNIX".  If
# your server is a Windows NT machine, set this parameter to "NT".  If you
# do not know, you can probably follow the instructions for "NT", but you
# can ask your Internet Service Provider whether your server is UNIX or
# Windows NT.
#---------------------------------------------------------------------------
$server_os = "NT";


#---------------------------------------------------------------------------
# *UNIX ONLY -- SKIP THIS QUESTION IF YOUR SERVER IS "NT".
#
# 3. What is the location of sendmail on your server?
# Sendmail is the standard UNIX mail program that this script uses to 
# email the order notification to the storeowner and the order receipt
# to the customer.  Typical locations of sendmail are /usr/lib/sendmail
# or /usr/sbin/sendmail but if your sendmail program is not located there, 
# you can ask your Internet Service Provider for the directory path to the
# sendmail program.
#---------------------------------------------------------------------------
$sendmail_path = "/usr/lib/sendmail";


#---------------------------------------------------------------------------
# *NT ONLY -- SKIP THIS QUESTION IF YOUR SERVER IS "UNIX".
#
# 4. What is the IP address (or hostname) of your mail server?
# Here you specify you mail server either by name (such as 
# postoffice.mystore.com) or by IP address (such as 123.456.789.0).
# If you do not know the name or IP address of your mail server, you
# should be able to ask your Internet Service Provider.
#---------------------------------------------------------------------------
#$smtp_address = "postoffice.mystore.com";
$smtp_address = "123.456.789.0";


#---------------------------------------------------------------------------
# *NT ONLY -- SKIP THIS QUESTION IF YOUR SERVER IS "UNIX".
#
# 5. The two variables $AF_INET and $SOCK_STREAM are used to connect to 
# the SMTP sockets.  If you are using Perl 5 and the sockets package
# Socket.pm, then you can set these variables to $AF_INET = AF_INET; and
# $SOCK_STREAM = SOCK_STREAM; respectively.  Otherwise, you can substitute
# default values such as 2 for AF_INET and 1 for SOCK_STREAM.  If 1 does
# not work for SOCK_STREAM, try using 2.
#---------------------------------------------------------------------------
#use Socket;                      # <--
#$AF_INET = AF_INET;              # Leave these lines commented out.
#$SOCK_STREAM = SOCK_STREAM;      # <--

$AF_INET = 2;                     # DO NOT CHANGE - THIS SETTING 
$SOCK_STREAM = 1;                 # SHOULD WORK.


#---------------------------------------------------------------------------
# 6. What email address would you like to send orders to?  
# This should be the store owner's email address.  IMPORTANT NOTE: When
# specifying this parameter instead of using the "@" sign in your email
# address, you must use "\@" - This is because the "@" sign is a special
# character in the Perl programming language and therefore must be 
# preceded by a "\" character in this case.
# For example, if you want to send all orders to sales@mystore.com then
# the parameter should be set to $store_email = "sales\@mystore.com"
#---------------------------------------------------------------------------
$store_email = "support\@uburst.com";


#---------------------------------------------------------------------------
# 7. What subject would you like to appear on all uShop emails that are 
# sent to the store owner?
# (This is the sentence/phrase that will appear in the "subject" area of
# emails sent to the store owner to notify him/her of a new order.)
#---------------------------------------------------------------------------
$store_subject = "Order Notification";


#---------------------------------------------------------------------------
# 8. What subject would you like to appear on all uShop emails that are 
# sent to the customer?
# (This is the sentence/phrase that will appear in the "subject" area of
# emails sent to the customer if they want an email receipt.)
#---------------------------------------------------------------------------
$customer_subject = "Order Receipt";


#---------------------------------------------------------------------------
# 9. Do you want to include the payment information on the email
# you send to the storeowner?
# Although including the customer's credit card information on
# the email to the storeowner simplifies the order process, it 
# really isn't the safest way to process orders.  If the storeowner's
# email account is on some other computer than the secure server,
# then there is a chance that the email could be intercepted on the way.
# The ideal option here is to select "NO" and then get your internet
# service provider to help you set up something like PGP encription to 
# securely email the order files to you OR use uShop's Order Reading applets
# to read the order files on-line from the secure server.
#---------------------------------------------------------------------------
$include_payinfo = "NO";


#---------------------------------------------------------------------------
# 10. What directory would you like to save order files?
# This is the directory on you're secure server where the order files
# will be saved.  You will have to create this directory on your secure
# server yourself and give the directory Execute and Write permissions 
# (chmod 733).  When specifying the directory parameter below, it must be
# specified RELATIVE TO YOUR CGI DIRECTORY.  
# For example, suppose you wanted to save order files in a subdirectory
# called "orders" in your CGI directory.  You would have to make a directory
# in your CGI directory called "orders", give it execute and write 
# permissions (chmod 733), and then specify the directory parameter below
# as $order_directory = "./orders/";
# In other words, if you want to use the directory specified below, just
# make a directory called "orders" in your cgi-bin directory and give it
# execute and write permissions (chmod 733).
#---------------------------------------------------------------------------
$order_directory = "./orders/";


#---------------------------------------------------------------------------
# 11. Would you like to enable the option to use uShop to read order files
# on-line?
# uShop provides an applet that you can setup on your store pages which
# would allow the storeowner to login and securely read the order files
# on-line from the secure server.  This would be very useful with the
# following uShop configuration:
#    a) The store owner selects "NO" to question 6 above so that no credit 
#       card info is sent with email notifications to the store owner.
#    b) When an order is place this script will send an email notification
#       of the order to the store owner containing the order, order number,
#       but no sensitive credit card information.
#    c) To securely get the credit card info, the store owner would go
#       to the uShop on-line order-reading applet page that he/she setup
#       on his/her secure server, type in the order number and his/her
#       personal password.
#    d) uShop will then securely display the full order including the
#       credit card info.
#
# So, if you are planning to set up an .html page to use uShop's on-line
# reader applet to allow the store owner to login and securely read
# the order files on-line, set this variable to "YES".
#---------------------------------------------------------------------------
$online_reader = "YES";


#---------------------------------------------------------------------------
# 12. If you are going to allow the store owner to securely read the order 
# files and get the credit card info on-line (question 11 above), what 
# password would you like?
#---------------------------------------------------------------------------
$online_password = "mypassword";


#---------------------------------------------------------------------------
# 13. Would you like to save customer information in a .csv file?
# If you set this parameter to "YES", uShop will maintain a file called
# address.csv which will be a comma-delimited file containing all of the
# customer information.  This information could later be imported into
# any spreadsheet or database program that you choose.
#
# Ten customer information parameters will be written to the file each 
# time: 
# If using the uShopOrderCGI applet the fields are: Customer Name,
# email, street1, street2, city, state, zip, country, phone, and then
# a blank field.
# If using the uShopOrderCustomCGI applet or the uShopOrderDeluxeCGI
# applet, then the fields are: Customer field1, field2, email, street1,
# street2, city, state, zip, country, and phone.
#
# Note: This file will be located in your "orders" directory.
#
# So set this parameter to "YES" if you will be needing this address.csv
# file.  Otherwise, set this parameter to "NO".
#---------------------------------------------------------------------------
$address_book = "NO";


#---------------------------------------------------------------------------
# And that's it!  
#
# Make sure you create the order directory that you specified in step 10
# and give it the appropriate permissions (chmod 733). 
# 
# Also, remember to copy this script to your CGI directory and give it
# read and execute permissions (chmod 755).
#
#
# End of SCRIPT SETUP.
#
#---------------------------------------------------------------------------


# Start uShop CGI script.

# Separate uShop data into key-value pairs.
&parse_form_data(*form_text);

# Set the parameters.
$uShop_command       = $form_text{'cmd'};
$uShop_filename      = $form_text{'ord'};
$uShop_data          = $form_text{'dat'};
$uShop_options       = $form_text{'opt'};
$uShop_mailto        = $form_text{'to'};
$uShop_password      = $form_text{'pw'};
$uShop_orderpage     = $form_text{'pag'};
$uShop_pTitle        = $form_text{'tle'};
$uShop_pInstructions = $form_text{'ins'};
$uShop_pSection1     = $form_text{'sc1'};
$uShop_pSection2     = $form_text{'sc2'};
$uShop_pSection3     = $form_text{'sc3'};
$uShop_pFootnote     = $form_text{'ftn'};
$uShop_returnurl     = $form_text{'ret'};
$uShop_thankyou      = $form_text{'tku'};
$uShop_customerInfo  = $form_text{'dt1'};
$uShop_shippingInfo  = $form_text{'dt2'};
$uShop_productInfo   = $form_text{'dt3'};
$uShop_discounttype  = $form_text{'dtype'};
$uShop_discounttable = $form_text{'dtable'};

# All uShop order files will begin a "U".
$uShop_filename = "U" . $uShop_filename;

##############################################
#           ORDER ID AND TOTAL               #
##############################################
$uShop_orderid       = $uShop_filename;
$uShop_total         = $form_text{'amt'};
##############################################

# Setup the mail program.   
if ($server_os eq "UNIX")
{
   # Append sendmail options to sendmail path.
   $mail_program = $sendmail_path . " -t -n";
}

# DECIPHER AND PERFORM uSHOP COMMAND.
if ($uShop_command =~ /write/)
{
   # Write the data to a file and email notification.
   $uShop_data = &validate_data($uShop_data);
   $uShop_filename = &validate_filename($uShop_filename);
   $uShop_mailto = &validate_email($uShop_mailto);
   &write_data($uShop_filename, $uShop_data);
   if ($uShop_options eq "receipt")
   {
      &mail_order($uShop_mailto, $store_email, $uShop_filename, $store_subject, $include_payinfo);
      &mail_order($store_email, $uShop_mailto, $uShop_filename, $customer_subject, "NO");
   }
   else
   {
      &mail_order($store_email, $store_email, $uShop_filename, $store_subject, $include_payinfo);
   }

   # Update address.csv file.
   if ($address_book eq "YES")
   {
      # Make sure that the write was not from a Contact form.
      if ($uShop_command =~ /contact/)
      {
         # Contact form - Don't update address book.
         # Do nothing.
      }
      else
      {
         # Write customer data to address.csv.
         &update_address_book($uShop_filename);
      }
   }

   # Display a receipt page.
   if ($uShop_thankyou eq "NONE")
   {
      # Let uShop generate a receipt.
      &show_receipt($uShop_filename,$uShop_returnurl,$uShop_command);
   }
   else
   {
      # Show a custom thankyou page.
      print "Location:  $uShop_thankyou", "\n\n";
   }
}
elsif ($uShop_command eq "read")
{
   # Display order file.
   $uShop_filename = &validate_filename($uShop_filename);
   &show_file($uShop_filename, $uShop_password, $uShop_options);
}
elsif ($uShop_command eq "order")
{
   # Create the order page.
   $uShop_orderpage = &validate_template($uShop_orderpage);
   &create_orderpage($uShop_orderpage, $uShop_data, $uShop_discounttype, $uShop_discounttable);
}
elsif ($uShop_command eq "print")
{
   # Create a page for printing.
   &create_printpage($uShop_pTitle, $uShop_pInstructions, $uShop_pSection1, $uShop_pSection2, $uShop_pSection3, $uShop_pFootnote, $uShop_data, $uShop_returnurl);
}
elsif ($uShop_command eq "pform")
{
   # Create a page for printing (with fields filled in).
   &print_form($uShop_pTitle, $uShop_pInstructions, $uShop_pSection1, $uShop_pSection2, $uShop_pSection3, $uShop_pFootnote, $uShop_returnurl, $uShop_customerInfo, $uShop_shippingInfo, $uShop_productInfo);
}
else
{
   # Show uShop Copyright.
   &display_message("uShop On-Line Shopping System", "Copyright (c) 1997-2000, Microburst Technologies, Inc.");
}

# End of uShop CGI Script.
exit(0);



#---------------------------------------------------------
# START OF uSHOP SUBROUTINES.
#---------------------------------------------------------

#---------------------------------------------------------
# Subroutine to write the data to a file.
#---------------------------------------------------------
sub write_data
{
   # Local variables associated with arguments.
   local ($file_name, $order_data) = @_;

   # Check for duplicate order file.
   if (-e $order_directory . $file_name)
   {
      # Prevent file over-writes.
      &return_error("Error","Duplicate order number.");
   }

   # Open file for writing.
   if (open(FILE, ">" . $order_directory . $file_name))
   {
      # Write the data to the file.
      print FILE $order_data;

      # Close the file.
      close(FILE);
   }
   else
   {
      # Indicate that the file was not opened.
      &return_error("File Error","Unable to open " . $order_directory . $file_name);
   }
}
# End of write_data()


#---------------------------------------------------------
# Subroutine to email the order notifications.
#---------------------------------------------------------
sub mail_order
{
   # Local variables associated with arguments.
   local ($from, $to, $file_name, $subject, $options) = @_;

   # Read the order file.  
   &read_file(*message,$file_name,$options);

   # Send the email
   if ($use_blat eq "YES")
   {
      # Use Blat To Send Mail.
      &send_mail_blat($from,$to,$subject,$message);   	
   }
   elsif ($server_os eq "NT")
   {
      # Send the email via sockets.
      &sockets_send_mail($from,$to,$subject,$message);
   }
   else
   {
      # Send the email via sendmail program.
      &send_mail($from,$to,$subject,$message);
   }
}
# End of mail_order()


#---------------------------------------------------------
# Subroutine to read a file.
#---------------------------------------------------------
sub read_file
{
   # Reference to arguments passed to this subroutine.
   local (*FILEDATA,$file_name,$options) = @_;

   # Other variables used in this subroutine.
   local ( $line, $payment_lines );

   # Open file for reading.
   open (FILE, $order_directory . $file_name) ||
      &return_error("File Error","Unable to read " . $order_directory . $file_name);

   # Reset number of payment lines left.
   $payment_lines = 0;

   # Initialize $FILEDATA.
   $FILEDATA = "";

   # Read entire file line by line.
   while (<FILE>)
   {
      # Set $line equal to the last line read from file.
      $line = $_;

      # Check if payment info should be included in email.
      if ($options eq "NO")
      {
         # Check if this line contains payment information.
         if ($line =~ /PAYMENT INFORMATION/i)
         {
            # There are four lines that contain payment info.
            $payment_lines = 4;
         }
         elsif ($line =~ /CHECKING INFORMATION/i)
         {
            # There are eight lines that contain payment info.
            $payment_lines = 8;
         }
         elsif ($payment_lines > 0)
         {
            # Decrement payment lines left.
            $payment_lines--;
         }
         else
         {
            # This line is not a payment line, add it to messagebody.
            $FILEDATA = $FILEDATA . $line;
         }
      }
      else
      {
         # Concatenate all lines onto messagebody.
         $FILEDATA = $FILEDATA . $line;
      }
   }

   # Close file.
   close(FILE);
}
# End of read_file()


#---------------------------------------------------------------------------
# Subroutine to display an order file (minus payment info) as an HTML page.
#---------------------------------------------------------------------------
sub show_receipt
{
   # Reference to arguments passed to this subroutine.
   local ($file_name,$returnurl,$options) = @_;

   # Other variables used in this subroutine.
   local ( $line, $payment_lines );

   # Start HTML page.
   print "Content-type: text/html\n\n";
   print "<!--            The uShop On-line Shopping System             -->\n";
   print "<!-- Copyright (c) 1997 - 2000, Microburst Technologies, Inc. -->  ";
   print "<HTML><HEAD><TITLE>Order Receipt</TITLE></HEAD>";
   print "<BODY><CENTER>";
   print "<H1>Thank You</H1>";
   print "<HR>";
   if ($options =~ /contact/)
   {
      # This is a contact form - so don't display order message.
   }
   else
   {
      print "<B>Your order has been placed.</B>";
      print "<HR>";
   }
   print "<BR>";
   print "</CENTER>";
   print "<font color=black face=courier size=2>";
   print "<pre>";

   # Open file for reading.
   open (FILE, $order_directory . $file_name) ||
      &return_error("File Error","Unable to read " . $order_directory . $file_name);

   # Reset number of payment lines left.
   $payment_lines = 0;

   # Read entire file line by line.
   while (<FILE>)
   {
      # Set $line equal to the last line read from file.
      $line = $_;

      # Check if this line contains payment information.
      if ($line =~ /PAYMENT INFORMATION/i)
      {
         # There are four lines that contain payment info.
         $payment_lines = 4;
      }
      elsif ($line =~ /CHECKING INFORMATION/i)
      {
         # There are eight lines that contain payment info.
         $payment_lines = 8;
      }
      elsif ($payment_lines > 0)
      {
         # Decrement payment lines left.
         $payment_lines--;
      }
      else
      {
         # This line is not a payment line, so display it.
         print $line;
         print "<BR>";
      }
   }

   # Close file.
   close(FILE);

   # End HTML page.
   print "</pre>";
   print "<BR>";
   print "<HR>";
   if ($returnurl ne "NONE")
   {
      print "<CENTER>[<A HREF='$returnurl'>BACK</A>]</CENTER>";
   }
   print "</BODY></HTML>";
}
# End of show_receipt()


#---------------------------------------------------------------------------
# Subroutine to display an entire order file as an HTML page.  This 
# subroutine is initiated by the uShopOrderReaderCGI applet.
#---------------------------------------------------------------------------
sub show_file
{
   # Reference to arguments passed to this subroutine.
   local ($file_name, $password, $options) = @_;

   # Check if on-line reader has been enabled.
   if ($online_reader ne "YES")
   {
      &return_error ("Access Denied","On-line Reader Has Not Been Enabled.");
   }

   # Check password.
   if ($password ne $online_password)
   {
      &return_error ("Access Denied","Incorrect Password.");
   }

   # Check if the file exists.
   if (! (-e $order_directory . $file_name))
   {
      &return_error ("Unknown Order Number","Unable to locate the order file.");
   }

   # Start HTML page.
   print "Content-type: text/html\n\n";
   print "<!--            The uShop On-line Shopping System             -->\n";
   print "<!-- Copyright (c) 1997 - 2000, Microburst Technologies, Inc. -->  ";
   print "<HTML><HEAD><TITLE>uShop Order File</TITLE></HEAD>";
   print "<BODY><CENTER>";
   print "<H1>";
   print $file_name;
   print "</H1>";
   print "</CENTER>";
   print "<HR>";
   print "<BR>";
   print "<font color=black face=courier size=2>";
   print "<pre>";

   # Open file for reading.
   open (FILE, $order_directory . $file_name) ||
      &return_error("File Error","Unable to read " . $order_directory . $file_name);

   # Read entire file line by line.
   while (<FILE>)
   {
      # Display line.
      print $_;
      print "<BR>";
   }

   # Close file.
   close(FILE);

   # Delete the file?
   if ($options eq "YES")
   {
      unlink($order_directory . $file_name);
      print "The order file was deleted.";
   }

   # End HTML page.
   print "</pre>";
   print "<BR>";
   print "<HR>";
   print "</BODY></HTML>";
}
# End of show_file()


#---------------------------------------------------------------------------
# Subroutine to display a page for printing.  (This subroutine is initiated
# by the uShopPrintButtonCGI and uShopPrintImageButtonCGI applets.
#---------------------------------------------------------------------------
sub create_printpage
{
   # Reference to arguments passed to this subroutine.
   local ($title,$instructions,$section1,$section2,$section3,$footnote,$datalist,$returnurl) = @_;

   # Start HTML page.
   print "Content-type: text/html\n\n";
   print "<!--            The uShop On-line Shopping System             -->\n";
   print "<!-- Copyright (c) 1997 - 2000, Microburst Technologies, Inc. -->  ";
   print "<HTML><HEAD><TITLE>";
   print $title;
   print "</TITLE>";
   print "<BODY><CENTER>";
   print "<H1>";
   print $title;
   print "</H1>";
   print "<HR>";
   print "<i>";
   print $instructions;
   print "</i>";
   print "<HR>";
   print "<BR><BR>";
   print "<TABLE BORDER=\"1\" CELLPADDING=\"3\" WIDTH=\"85%\">";
   print "<TR>";
   print "<TD VALIGN=\"MIDDLE\" BGCOLOR=\"#C0C0C0\">";
   print "<H4 ALIGN=\"CENTER\">";
   print $section1;
   print "</TD></TR>";
   print "<TR>";
   print "<TD>";
   print "<H4><BR><BR><BR><BR>";
   print "</TD></TR>";
   print "<TR>";
   print "<TD VALIGN=\"MIDDLE\" BGCOLOR=\"#C0C0C0\">";
   print "<H4 ALIGN=\"CENTER\">";
   print $section2;
   print "</TD></TR>";
   print "<TR>";
   print "<TD>";
   print "<H4><BR><BR><BR><BR>";
   print "</TD></TR>";
   print "<TR>";
   print "<TD VALIGN=\"MIDDLE\" BGCOLOR=\"#C0C0C0\">";
   print "<H4 ALIGN=\"CENTER\">";
   print $section3;
   print "</TD></TR>";
   print "<TR>";
   print "<TD>";
   print "<H4><BR><BR><BR><BR>";
   print "</TD></TR>";
   print "<TR>";
   print "<TD VALIGN=\"MIDDLE\" BGCOLOR=\"#C0C0C0\">";
   print "<H4 ALIGN=\"CENTER\">Product Information";
   print "</TD></TR>";
   print "<TR>";
   print "<TD>";
   print "<font color=black face=courier size=3>";
   print "<pre>";
   print $datalist;
   print "</pre>";
   print "</font>";
   print "</TD></TR>";
   print "</TABLE>";
   print "<BR>";
   print "<I>";
   print $footnote;
   print "</I>";
   print "</CENTER>";
   if ($returnurl ne "NONE")
   {
      print "<BR>";
      print "<CENTER>[<A HREF='$returnurl'>BACK</A>]</CENTER>";
   }
   print "</BODY></HTML>";
}
# End of create_printpage()


#---------------------------------------------------------------------------
# Subroutine to display a page for printing (with fields filled in).  This
# subroutine is initiated by the uShopPrintFormCGI applet.
#---------------------------------------------------------------------------
sub print_form
{
   # Reference to arguments passed to this subroutine.
   local ($title,$instructions,$section1,$section2,$section3,$footnote,$returnurl,$data1,$data2,$data3) = @_;

   # Start HTML page.
   print "Content-type: text/html\n\n";
   print "<!--            The uShop On-line Shopping System             -->\n";
   print "<!-- Copyright (c) 1997 - 2000, Microburst Technologies, Inc. -->  ";
   print "<HTML><HEAD><TITLE>";
   print $title;
   print "</TITLE>";
   print "<BODY><CENTER>";
   print "<H1>";
   print $title;
   print "</H1>";
   print "<HR>";
   print "<i>";
   print $instructions;
   print "</i>";
   print "<HR>";
   print "<BR><BR>";
   print "<TABLE BORDER=\"1\" CELLPADDING=\"3\" WIDTH=\"85%\">";

   print "<TR>";
   print "<TD VALIGN=\"MIDDLE\" BGCOLOR=\"#C0C0C0\">";
   print "<H4 ALIGN=\"CENTER\">";
   print $section1;
   print "</TD></TR>";
   print "<TR>";
   print "<TD>";
   print "<font color=black face=courier size=3>";
   print "<pre>";
   print $data1;
   print "</pre>";
   print "</font>";
   print "</TD></TR>";

   print "<TR>";
   print "<TD VALIGN=\"MIDDLE\" BGCOLOR=\"#C0C0C0\">";
   print "<H4 ALIGN=\"CENTER\">";
   print $section2;
   print "</TD></TR>";
   print "<TR>";
   print "<TD>";
   print "<font color=black face=courier size=3>";
   print "<pre>";
   print $data2;
   print "</pre>";
   print "</font>";
   print "</TD></TR>";

   print "<TR>";
   print "<TD VALIGN=\"MIDDLE\" BGCOLOR=\"#C0C0C0\">";
   print "<H4 ALIGN=\"CENTER\">";
   print $section3;
   print "</TD></TR>";
   print "<TR>";
   print "<TD>";
   print "<H4><BR><BR><BR><BR>";
   print "</TD></TR>";

   print "<TR>";
   print "<TD VALIGN=\"MIDDLE\" BGCOLOR=\"#C0C0C0\">";
   print "<H4 ALIGN=\"CENTER\">Product Information";
   print "</TD></TR>";
   print "<TR>";
   print "<TD>";
   print "<font color=black face=courier size=3>";
   print "<pre>";
   print $data3;
   print "</pre>";
   print "</font>";
   print "</TD></TR>";

   print "</TABLE>";
   print "<BR>";
   print "<I>";
   print $footnote;
   print "</I>";
   print "</CENTER>";
   if ($returnurl ne "NONE")
   {
      print "<BR>";
      print "<CENTER>[<A HREF='$returnurl'>BACK</A>]</CENTER>";
   }
   print "</BODY></HTML>";
}
# End of print_form()


#---------------------------------------------------------------------------
# Subroutine to write address data to a .csv address file.
#---------------------------------------------------------------------------
sub update_address_book
{
   # Reference to arguments passed to this subroutine.
   local ($file_name) = @_;

   # Other variables used in this subroutine.
   local ( $line, $customer_lines, $customer_found );

   # Reset customer flags.
   $customer_found = 0;
   $customer_lines = 0;

   # Open file for reading.
   open (RFILE, $order_directory . $file_name) ||
      &return_error("File Error","Unable to read " . $order_directory . $file_name);

   # Open file for appending.
   if (open(AFILE, ">>" . $order_directory . "address.csv"))
   {
      # Read entire file line by line.
      while (<RFILE>)
      {
         # Set $line equal to the last line read from file.
         $line = $_;

         # Has customer information been found.
         if ($customer_found == 1)
         {
            # Write 10 lines to file.
            if ($customer_lines < 10)
            {
               $customer_lines++;
               if ($customer_lines == 10)
               {
                  # Leave the last carriage return.
                  # Do nothing.
               }
               else
               {
                  $line =~ tr/\n/,/;
               }
               print AFILE $line;
            }
         }
         # Check if this line contains customer information.
         elsif ($line =~ /CUSTOMER INFORMATION/i)
         {
            # Indicate that customer information was found.
            $customer_found = 1;
         }
      }

      # Close file.
      close(RFILE);

      # Close the file.
      close(AFILE);
      
      # Do a chmod on the file.
      chmod(0777,$order_directory . "address.csv");
   }
   else
   {
      # Indicate that the file was not opened.
      &return_error("File Error","Unable to open " . $order_directory . "address.csv");
   }
}
# End of update_address_book()


#---------------------------------------------------------------------------
# Subroutine to output the orderpage template and transfer the data
# and current discount options to it via the applet parameters DATA,
# TYPE, and RATE.
#---------------------------------------------------------------------------
sub create_orderpage
{
   # Reference to arguments passed to this subroutine.
   local ($orderpage, $dataparam, $discount_type, $discount_table) = @_;

   # Other variables used in this subroutine.
   local ( $line, $data_flag );

   # Reset the data flag.
   $data_flag = 0;

   # Check if the file exists.
   if (! (-e $orderpage))
   {
      &return_error ("Unknown Order Page","Unable to locate order page: " . $orderpage);
   }

   # Open file for reading.
   open (FILE, $orderpage) ||
      &return_error("File Error","Unable to open " . $orderpage);

   # Start HTML page.
   print "Content-type: text/html\n\n";

   # Read and output the entire order page file line by line.
   while (<FILE>)
   {
      # Set $line equal to the last line read from file.
      $line = $_;

      # Check if this line contains the start of the order applet.
      if ($line =~ /\"uShopOrder/)
      {
         $data_flag = 1;
      }

      # Output the line.
      print $line;

      # Output the data and discount parameters if data flag is set.
      if ($data_flag > 0)
      {
         print $dataparam;
         $data_flag = 0;
         
         if ($discount_type ne "")
         {
            print "<PARAM NAME=type VALUE=\"" . $discount_type . "\">\n";
            print "<PARAM NAME=rate VALUE=\"" . $discount_table . "\">\n";
         }            
      }
   }

   # Close file.
   close(FILE);
}
# End of create_orderpage()


#---------------------------------------------------------
# Subroutine to parse form data passed to this script.
# This subroutine works for both GET and POST methods.
#---------------------------------------------------------
sub parse_form_data
{
   # Reference to argument passed to this subroutine.
   local (*FORM_DATA) = @_;

   # Other variables used in this subroutine.
   local ( $request_method,
           $query_string,
           @key_value_pairs,
           $key_value,
           $key,
           $value);

   #---------------------------------------------------------
   # Determine request method and set $query_string = data.
   #---------------------------------------------------------
   $request_method = $ENV{'REQUEST_METHOD'};
   if ($request_method eq "GET")
   {
      $query_string = $ENV{'QUERY_STRING'};
   }
   elsif ($request_method eq "POST")
   {
      #read (STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
      &display_message("uShop On-Line Shopping System", "Copyright (c) 1997-2000, Microburst Technologies, Inc.");
   }
   else
   {
      # Call subroutine to display error message.
      &return_error ("Unsupported Method",
                     "Server must use GET or POST.");
   }

   #---------------------------------------------------------
   # Split query string, decode, and create key-value table.
   #---------------------------------------------------------
   @key_value_pairs = split (/&/, $query_string);
   foreach $key_value (@key_value_pairs)
   {
      ($key, $value) = split (/=/, $key_value);
      $value =~ tr/+/ /;
      $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg;

      if (defined($FORM_DATA{$key}))
      {
         $FORM_DATA{$key} = join ("\0", $FORM_DATA{$key}, $value);
      }
      else
      {
         $FORM_DATA{$key} = $value;
      }
   }
}
# End of parse_form_data()


#---------------------------------------------------------
# Subroutine to display an error message.
#---------------------------------------------------------
sub return_error
{
   # Local variables associated with arguments.
   local ($title, $message) = @_;

   # Create an HTML page to display a message.
   print "Content-type: text/html\n\n";
   print "<!--            The uShop On-line Shopping System             -->\n";
   print "<!-- Copyright (c) 1997 - 2000, Microburst Technologies, Inc. -->  ";
   print "<HTML><HEAD><TITLE>Error</TITLE></HEAD>";
   print "<BODY><CENTER>";
   print "<H1>";
   print $title;
   print "</H1>";
   print "<HR>";
   print $message;
   print "<HR>";
   print "</CENTER>";
   print "</BODY></HTML>";
   
   exit;
}
#End of return_error.


#---------------------------------------------------------
# Subroutine to display a message on an HTML page.
#---------------------------------------------------------
sub display_message
{
   # Local variables associated with arguments.
   local ($title, $message) = @_;

   # Create an HTML page to display a message.
   print "Content-type: text/html\n\n";
   print "<!--            The uShop On-line Shopping System             -->\n";
   print "<!-- Copyright (c) 1997 - 2000, Microburst Technologies, Inc. -->  ";
   print "<HTML><HEAD><TITLE>Message</TITLE></HEAD>";
   print "<BODY><CENTER>";
   print "<H1>";
   print $title;
   print "</H1>";
   print "<HR>";
   print $message;
   print "<HR>";
   print "</CENTER>";
   print "</BODY></HTML>";
   
   exit;
}
#End of display_message.


#---------------------------------------------------------
# Subroutine to send mail via 'sendmail'.
#---------------------------------------------------------
sub send_mail
{
   # Local variables associated with arguments.
   local ($sendfrom, $sendto, $messagesubject, $messagebody) = @_;

   # Open sendmail program.
   open (MAIL, "|$mail_program") ||
      &return_error("Email Error","Unable to open sendmail.");

   # Fill in email info and send message.
   print MAIL "To: " . $sendto . "\n";
   print MAIL "From: " . $sendfrom . "\n";
   print MAIL "Subject: " . $messagesubject . "\n\n";
   print MAIL $messagebody . "\n";

   # Close the sendmail program.
   close (MAIL);
}
# End of send_mail()


#---------------------------------------------------------
# Subroutine to send mail via sockets.
#---------------------------------------------------------
sub sockets_send_mail
{
   my ($from, $to, $subject, $message) = @_;

   my ($replyaddr) = $from;
   
   my ($proto, $port);   
   
   if (!$to) 
   {
      return;
   }

   $proto = (getprotobyname('tcp'))[2];
   
   $port  = 25;

   $smtpaddr = ($smtp_address =~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/)
                    ? pack('C4',$1,$2,$3,$4)
                    : (gethostbyname($smtp_address))[4];

   if (!defined($smtpaddr)) 
   { 
      &return_error("Configuration Error","No SMTP address specified"); 
   }

   if (!socket(S, $AF_INET, $SOCK_STREAM, $proto))
   { 
      &return_error("Configuration Error","Unable to create socket"); 
   }

   if (!connect(S, pack('Sna4x8', $AF_INET, $port, $smtpaddr))) 
   { 
      &return_error("Configuration Error","Unable to connect to socket"); 
   }

   my($oldfh) = select(S); 
   $| = 1; select($oldfh);

   $_ = <S>; 
   if (/^[45]/) 
   { 
      close S; 
      return;
   }

   print S "helo localhost\r\n";
   $_ = <S>; 
   if (/^[45]/) 
   { 
      close S; 
      return; 
   }

   print S "mail from: $from\r\n";
   $_ = <S>; 
   if (/^[45]/) 
   { 
      close S; 
      return; 
   }
   
   print S "rcpt to: $to\r\n";
   $_ = <S>; 
   if (/^[45]/) 
   { 
      close S; 
      return; 
   }

   print S "data\r\n";
   $_ = <S>; 
   if (/^[45]/) 
   { 
      close S; 
      return; 
   }

   # Send message.
   print S "X-Mailer: Sendmail \r\n";
   print S "Mime-Version: 1.0\r\n";
   print S "Content-Type: text/plain; charset=us-ascii\r\n";
   print S "To: $to\r\n";
   print S "From: $from\r\n";
   print S "Reply-to: $replyaddr\r\n" if $replyaddr;
   print S "Subject: $subject\r\n\r\n";
   print S "$message";
   print S "\r\n.\r\n";

   $_ = <S>; 
   if (/^[45]/) 
   { 
      close S; 
      return; 
   }

   print S "quit\r\n";
   $_ = <S>;

   close S;
   
} # End of sockets_send_mail()


# Subroutine to send mail via Blat.
sub send_mail_blat
{
   local ($sendfrom, $sendto, $messagesubject, $messagebody) = @_;
   local ($tempfile);

   # Output message to a temporary file.
   $tempfile = $order_directory . "temp.blat";
  
   # Output a temporary file
   open(MAIL,">$tempfile") || die("Cannot open $tempfile -- Check Directory Permissions : $!"); 

   print MAIL "To: $sendto\n";
   print MAIL "From: $sendfrom\n";
   print MAIL "Subject: $messagesubject\n\n";
   print MAIL "$messagebody";
   print MAIL "\n\n";
   close (MAIL);
 
   #'use' the process module.
   use Win32::Process;
        
   # theWin32:: module. Includes the Win32 error checking etc.
   use Win32;
        
   sub Error
   { 
      print Win32::FormatMessage( Win32::GetLastError() );
   }

   #Create the process object.
   Win32::Process::Create($ProcessObj, $blat_path, "Blat $tempfile -t $sendto -s \"$messagesubject\" -f $sendfrom -i \"$sendfrom\"", 0, DETACHED_PROCESS, ".")|| die &Error; 

   #Wait for the process to end. NO timeout 
   $ProcessObj->Wait(0);
}
# End of send_mail_blat()


# Subroutine to remove/replace special characters.
sub validate_data
{
   local ($vstring) = @_;

   $vstring =~ s/\#!/ /g; # remove any #! signs
   $vstring =~ s/\</ /g;  # remove less-thans
   $vstring =~ s/\>/ /g;  # remove greater-thans
   #$vstring =~ s/\//-/g; # remove forward slashes
   $vstring =~ s/\\/ /g;  # remove backward slashes
   $vstring =~ s/\"/ /g;  # remove double quotes

   return $vstring;
}


# Subroutine to remove/replace special characters.
sub validate_filename
{
   local ($vstring) = @_;

   $vstring =~ s/[^A-z0-9]//g;

   return $vstring;
}


# Subroutine to remove/replace special characters.
sub validate_template
{
   local ($vstring) = @_;

   if (($vstring =~ /.template$/) || ($vstring =~ /.html$/))
   {
      $vstring =~ s/[^.\/A-z0-9]//g;
   }
   else
   {
      $vstring = "INVALID";
   }

   return $vstring;
}


# Subroutine to remove/replace special characters.
sub validate_email
{
   local ($vstring) = @_;

   $vstring =~ s/[^-.\@A-z0-9]//g;

   return $vstring;
}

